unit TXPC;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, BCPort, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    BComPort1: TBComPort;
    Button6: TButton;
    cbPort: TComboBox;
    Label2: TLabel;
    Image1: TImage;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    ProgressBar1: TProgressBar;
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
   a: array [1 .. 561] of Byte;
   var SaveF, SaveV:  File of byte;
   b: Byte;
   i, counter: integer;
   FilePath,Filename:string;
   CurrentDate: tDateTime;

implementation

uses Unit2, Unit3;

{$R *.dfm}

function GetExePath:string;begin Result:=ExtractFilePath(paramstr(0));end;

procedure TForm1.Button2Click(Sender: TObject);   //Disconnect TX
begin
  BComPort1.Port := cbPort.Text;
  BComPort1.Open;
  BComPort1.ClearBuffer(True,True);
  b:=$61;
  BComPort1.Write(b,1);
  BComPort1.Close;
  Application.Terminate;
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
     EnumComPorts(cbPort.Items);
     cbPort.ItemIndex := 1;
     FilePath:=GetExePath;
     FilePath:=FilePath+'Model Configuration';
     SaveDialog1.InitialDir:=FilePath;
     OpenDialog1.InitialDir:=FilePath;
     CurrentDate := Now;
     //ShowMessage(DateToStr(CurrentDate));

end;

procedure TForm1.Button3Click(Sender: TObject);        // Load File
begin
     with OpenDialog1 do
      if Execute then
      begin
      AssignFile(SaveF, OpenDialog1.FileName);
      Reset(SaveF);
      counter:=1;
      repeat
      Read(SaveF, a[counter]);
      counter:=counter+1;
      until counter>561;
     CloseFile(SaveF) ;
     Button5.Enabled:=true;
     end;
end;

procedure TForm1.Button4Click(Sender: TObject);    //Save File
begin
     with SaveDialog1 do
      if Execute then
      begin
      AssignFile(SaveV, SaveDialog1.FileName);
      Rewrite(SaveV);
      counter:=1;
      repeat
        write(SaveV, a[counter]);
        counter:=counter+1;
      until counter>561;
     CloseFile(SaveV) ;
     end;
end;

procedure TForm1.Button5Click(Sender: TObject);   //PC => TX
begin
BComPort1.Port := cbPort.Text;
BComPort1.Open;
BComPort1.ClearBuffer(True,True);
  counter:=1;
  b:=$31;
  BComPort1.Write(b,1);
  b:=$33;
  BComPort1.Write(b,1);
  Sleep(50);
  ProgressBar1.Visible:=True;
      repeat
        BComPort1.Write(a[counter],1);
        counter:=counter+1;
        ProgressBar1.Position:=Counter;
      until counter>561;
  BComPort1.Close;
  if (not Assigned(Form3)) then   //    ( , 
       Form3:=TForm3.Create(Self);    //  )
   Form3.Show; // ( Form2.ShowModal)  
   ProgressBar1.Visible:=False;
end;

procedure TForm1.Button6Click(Sender: TObject); //TX => PC
begin
BComPort1.Port := cbPort.Text;
BComPort1.Open;
BComPort1.ClearBuffer(True,True);
  b:=$31;
  BComPort1.Write(b,1);
  b:=$32;
  BComPort1.Write(b,1);
  Sleep(250);
  ProgressBar1.Visible:=True;
  counter:=1;
  repeat
        BComPort1.Read(a[counter],1);
        Sleep(5);
        counter:=counter+1;
        ProgressBar1.Position:=Counter;
      until counter>561;
  BComPort1.Close;
  FileName:='';
  for i:=1 to 8 do
  begin
  FileName:=FileName+chr(a[i]);
  end;
  FileName:=FileName+DateToStr(CurrentDate);
  SaveDialog1.FileName:=Filename;
  if (not Assigned(Form2)) then   //    ( , 
       Form2:=TForm2.Create(Self);    //  )
   Form2.Show; // ( Form2.ShowModal)  
   ProgressBar1.Visible:=False;
   Button4.Enabled:=true;
end;


end.
